/*
 * Copyright (C) 2002  Carl M. Gregory - MC_8
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

static void add_delay(char *nick, char *uhost, char *hand, char *chan,
                      int time) {
	delay_t *new = NULL, *cur;
	ContextNote(REPORT_BUG);
	cur = find_delay(nick, chan);
	if (cur)
		return;
	new = nmalloc(sizeof(struct delay_table));
	if (!new)
		return;
	new->next = delaydata;
	delaydata = new;
	new->nick = nmalloc(strlen(nick) + 1);
	strcpy(new->nick, nick);
	new->uhost = nmalloc(strlen(uhost) + 1);
	strcpy(new->uhost, uhost);
	new->hand = nmalloc(strlen(hand) + 1);
	strcpy(new->hand, hand);
	new->channel = nmalloc(strlen(chan) + 1);
	strcpy(new->channel, chan);
	new->time = time;
}

static void del_delay(delay_t *goner) {
	delay_t *tmp = NULL, *old = NULL;
	ContextNote(REPORT_BUG);
	for (tmp = delaydata; tmp; old = tmp, tmp = tmp->next) {
		if (tmp == goner) {
			if (old)
				old->next = tmp->next;
			else
				delaydata = tmp->next;
			nfree(tmp->nick);
			nfree(tmp->uhost);
			nfree(tmp->hand);
			nfree(tmp->channel);
			nfree(tmp);
			break;
		}
	}
}

static delay_t *find_delay(char *nick, char *channel) {
	delay_t *d;
	ContextNote(REPORT_BUG);
	for (d = delaydata; d; d = d->next)
		if (!strcasecmp(nick, d->nick) && !strcasecmp(channel, d->channel))
			return d;
	return NULL;
}

static void check_delay() {
	delay_t *d = NULL;
	for (d = delaydata; d; d = d->next) {
		if ((d->time) && (d->time <= now)) {
			mc_greet_sendgreet(d->nick, d->uhost, d->hand, d->channel);
			return;
		}
	}
}
