/*
 * Copyright (C) 2002  Carl M. Gregory - MC_8
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef _EGG_MOD_MC_GREET_H
#define _EGG_MOD_MC_GREET_H

#ifdef MAKING_MC_GREET

typedef struct greet_table {
	struct greet_table *next;
	char *channel;
	char *message;
	int method;
} greet_t;

typedef struct delay_table {
	struct delay_table *next;
	char *nick;
	char *uhost;
	char *hand;
	char *channel;
	int time;
} delay_t;

// mc_data.c
static void add_greet(char chan[CHANLEN+1], char mesg[MESGLEN+1], int method);
static void del_greet(greet_t *goner);
static greet_t *findgreet(char *channel);
static void chk_validchan();
static void load_datafile();
static void save_datafile(int quiet);

// mc_delay.c
static void add_delay
	(char *nick, char *uhost, char *hand, char *chan, int time);
static void del_delay(delay_t *goner);
static delay_t *find_delay(char *nick, char *channel);
static void check_delay();

// mc_greet.c
static void mc_greet_hook_secondly();
static void mc_greet_report(int idx, int details);
static char *mc_greet_close();
char *mc_greet_start(Function *global_funcs);

// mc_mem.c
static int mc_greet_expmem();
static void free_mc_greet();
static int greet_expmem();
static void free_greet();
static int delay_expmem();
static void free_delay();
static int preset_expmem();

// mc_misc.c
static struct chanset_t *onchan(char *nick, char *chan);
static int matchattr(struct userrec *u, char *flags, char *chan);

// mc_on_dcc.c
static int cmd_addgreet(struct userrec *u, int idx, char *par);
static int cmd_delgreet(struct userrec *u, int idx, char *par);
static int cmd_greets(struct userrec *u, int idx, char *par);

// mc_on_join.c
static int mc_greet_join(char *nick, char *uhost, char *hand, char *chan);
static void mc_greet_sendgreet(char *nick, char *uhost, char *hand, char *chan);

#ifndef strncpyz
#define strncpyz(target, source, len) do {      \
        strncpy((target), (source), (len) - 1); \
        (target)[(len) - 1] = 0;                \
} while (0)
#endif

#endif /* MAKING_MC_GREET */

#endif /* _EGG_MOD_MC_GREET_H */