/*
 * Copyright (C) 2002  Carl M. Gregory - MC_8
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


static int mc_greet_expmem() {
	return greet_expmem() + delay_expmem() + preset_expmem();
}

static int greet_expmem() {
	int size = 0;
	greet_t *l;
	ContextNote(REPORT_BUG);
	for (l = greetdata; l; l = l->next) {
		size += sizeof(struct greet_table);
		size += sizeof(l->channel);
		size += sizeof(l->message);
	}
	return size;
}

static int greet_recnum() {
	int num = 0;
	greet_t *l;
	ContextNote(REPORT_BUG);
	for (l = greetdata; l; l = l->next)
		num++;
	return num;
}

static void free_greet() {
	greet_t *l = NULL, *ll = NULL;
	ContextNote(REPORT_BUG);
	for (l = greetdata; l; l = ll) {
    ll = l->next;
    nfree(l->channel);
    nfree(l->message);
    nfree(l);
	}
	greetdata = NULL;
}

static int delay_expmem() {
	int size = 0;
	delay_t *l;
	ContextNote(REPORT_BUG);
	for (l = delaydata; l; l = l->next) {
		size += sizeof(struct delay_table);
		size += sizeof(l->nick);
		size += sizeof(l->uhost);
		size += sizeof(l->hand);
		size += sizeof(l->channel);
	}
	return size;
}

static int delay_recnum() {
	int num = 0;
	delay_t *l;
	ContextNote(REPORT_BUG);
	for (l = delaydata; l; l = l->next)
		num++;
	return num;
}

static void free_delay() {
	delay_t *l = NULL, *ll = NULL;
	ContextNote(REPORT_BUG);
	for (l = delaydata; l; l = ll) {
    ll = l->next;
    nfree(l->nick);
    nfree(l->uhost);
    nfree(l->hand);
    nfree(l->channel);
    nfree(l);
	}
	delaydata = NULL;
}

static void free_mc_greet() {
  free_greet();
  free_delay();
}

static int preset_expmem() {
	return sizeof(validuser)+
	       sizeof(wait)+
	       sizeof(svs_mode)+
	       sizeof(datafile)+
	       sizeof(addremove_access)+
	       sizeof(view_access)+
	       sizeof(svs_notify);
}
