/*
 * Copyright (C) 2002  Carl M. Gregory - MC_8
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


static int mc_greet_join(char *nick, char *uhost, char *hand, char *chan) {
	greet_t *greet = NULL;
	ContextNote(REPORT_BUG);
	if ((!validuser) && (hand[0] == '*'))
		return;
	greet = findgreet(chan);
	if (!greet)
		return;
	if (!wait)
		mc_greet_sendgreet(nick, uhost, hand, chan);
	else
		add_delay(nick, uhost, hand, chan, now+wait);
	return 0;
}


static void mc_greet_sendgreet(char *nick, char *uhost, char *hand, char *chan)
{
	greet_t *greet = NULL;
	delay_t *delay = NULL;
	char mesg[MESGLEN+1], *mesg_;
	int size;
	ContextNote(REPORT_BUG);
	delay = find_delay(nick, chan);
	if (delay)
		del_delay(delay);
	greet = findgreet(chan);
	if (!greet || !onchan(nick, chan))
		return;
	strncpyz(mesg, regsub("%nick",
	                regsub("%uhost",
	                 regsub("%handle",
	                  regsub("%channel",
	                   greet->message,
	                  chan, 0),
	                 hand, 0),
	                uhost, 0),
	               nick, 0), sizeof(mesg));
	for (mesg_ = strtok(mesg, "\n"); mesg_; mesg_ = strtok(NULL, "\n"))
		dprintf(DP_HELP, "%s %s :%s\n",
		        greet->method ? "NOTICE" : "PRIVMSG", nick, mesg_);
}

static cmd_t my_joins[] = {
	{"*", "", (Function) mc_greet_join, "mc_greet"},
	{0, 0, 0, 0}
};
